<?php

/**
 * GepTiposolicitacao
 *
 * This class has been auto-generated by the Doctrine ORM Framework
 *
 * @package    DbModel
 * @subpackage Model
 * @author     robertomartins - 14/04/2011 18:29:16 <development@setforms.com>
 * @version    Release: SVN: $Id: Builder.php 6508 2009-10-14 06:28:49Z jwage $
 */
class GepTiposolicitacao extends DaoGepTiposolicitacao
{


    /**
     * Retorna dados de um tipo de solicitacao.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $tp_fluxo Tipo de fluxo.
     *
     * @return Ambigous <mixed, NULL>|boolean
     */
    public static function consultaTipoSolicitacaoFluxo($nrorg, $tp_fluxo){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRTIPOFLUXO = ?',
                array(
                 $nrorg,
                 $tp_fluxo,
                )
            );
            return $obj;

        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Retorna dados de um tp de solicitacao.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $tp_fluxo Tipo do fluxo.
     * @param integer $tp_soli  Tipo da solicitacao.
     *
     * @return Ambigous <mixed, NULL>|boolean
     */
    public static function consultaTipoSolicitacao($nrorg, $tp_fluxo, $tp_soli){
        try {
            $obj = self::getObjectByWhere(
                'NRORG = ? AND NRTIPOFLUXO = ? AND NRTIPOSOLICITACAO = ?',
                array(
                 $nrorg,
                 $tp_fluxo,
                 $tp_soli,
                )
            );
            return $obj;
        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


    /**
     * Retorna dados de tipo de solicitacao por tipo de fluxo.
     *
     * @param integer $nrorg    Numero da Organizacao.
     * @param integer $tp_fluxo Tipo de fluxo.
     *
     * @return Ambigous <mixed, NULL>|boolean
     */
    public static function consultaListaTipoSolicitacao($nrorg, $tp_fluxo){
        try {
            $obj = self::getObjectsByWhere(
                'NRORG = ? AND NRTIPOFLUXO = ?',
                array(
                 $nrorg,
                 $tp_fluxo,
                )
            );
            return $obj;

        } catch(Exception $e) {
            showClassError($e, __FUNCTION__, __LINE__);
            return false;
        }
    }


}